# SoMFEnum Class Reference
[Field classes]

`#include <Inventor/fields/SoMFEnum.h>`

Inheritance diagram for SoMFEnum:

List of all members.

## Detailed Description

The SoMFEnum class is a container for a set of enumerated values.

This field is used where nodes, engines or other field containers needs to store values constrained to be from an enumerated set.

A field of this type stores its values to file as the symbolic names, rather than the actual integer values.

See also:
  SoSFEnum

## Public Member Functions

void | setValue (const SbName name)
void | set1Value (const int idx, const SbName name)
void | setEnums (const int num, const int *const values, const SbName *const names)
int | getNumEnums (void) const
int | getEnum (const int idx, SbName &name) const

## Static Public Member Functions

void | initClass (void)

## Protected Member Functions

virtual SbBool | findEnumValue (const SbName &name, int &value)
virtual SbBool | findEnumName (int value, const SbName *&name) const

## Protected Attributes

SbBool | legalValuesSet
int | numEnums
int * | enumValues
SbName * | enumNames

## Member Function Documentation

void SoMFEnum::initClass | ( | void |  | ) | `[static]`

| Internal method called upon initialization of the library (from SoDB::init()) to set up the type system. Reimplemented from SoMField. Reimplemented in SoMFBitMask.

void SoMFEnum::setValue | ( | const SbName | name | ) |

| Set this field to contain a single value by specifying an enumeration string.

void SoMFEnum::set1Value | ( | const int | idx,
|  | const SbName | name
| ) |

| Set the value at idx to the enumeration value represented by name.

void SoMFEnum::setEnums | ( | const int | num,
|  | const int *const | vals,
|  | const SbName *const | names
| ) |

| Makes a set of num enumeration names map to vals.

int SoMFEnum::getNumEnums | ( | void |  | ) | const

Returns the number of enum names the SoSFEnum object understands.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

int SoMFEnum::getEnum | ( | const int | idx,
|  | SbName & | name
| ) | const

Returns the value of the Nth enum this SoSFEnum object understands, and mutates name to contain the Nth enum's name.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

SbBool SoMFEnum::findEnumValue | ( | const SbName & | name,
|  | int & | val
| ) | `[protected, virtual]`

| Return in val the enumeration value which matches the given enumeration name. Returns `TRUE` if name is a valid enumeration string, otherwise `FALSE`.

SbBool SoMFEnum::findEnumName | ( | int | value,
|  | const SbName *& | name
| ) | const`[protected, virtual]`

| Set the enumeration name which matches the given enumeration value. Returns `TRUE` if value is a valid enumeration value, otherwise `FALSE`.

## Member Data Documentation

SbBool SoMFEnum::legalValuesSet`[protected]`

| Is `TRUE` if a set of enum name-to-value mappings has been set.

int SoMFEnum::numEnums`[protected]`

| Number of enumeration mappings.

int * SoMFEnum::enumValues`[protected]`

| Array of enumeration values. Maps 1-to-1 with the enumNames.

SbName * SoMFEnum::enumNames`[protected]`

| Array of enumeration names. Maps 1-to-1 with the enumValues.

The documentation for this class was generated from the following files:

- SoMFEnum.h
- SoMFEnum.cpp